
////////////////////                           ///////////////////
////////////////////     Angle class ; CPP     ///////////////////
////////////////////                           ///////////////////

#include "Angle.h"
#include "Dvector3D.h"
#include <math.h>

using namespace std ;

Angle::Angle()
{
  iatom1=-1;
  iatom2=-1;
  iatom3=-1;
}

Angle::Angle(const int ia1, 
	     const int ia2,
	     const int ia3)
{
  iatom1=ia1;
  iatom2=ia2;
  iatom3=ia3;
}

Angle::Angle(const Angle& an)
{
  iatom1=-1;
  iatom2=-1;
  iatom3=-1;
  copy(an);
}

Angle::~Angle()
{
}

void Angle::copy(const Angle& an)
{
  if(this==&an) return;
  iatom1=an.iatom1;
  iatom2=an.iatom2;
  iatom3=an.iatom3;
}

int Angle::get_iatom1 ( ) const 
{
  return iatom1;
}

int Angle::get_iatom2 ( ) const
{
  return iatom2;
}
 
int Angle::get_iatom3 ( ) const
{
  return iatom3;
} 

void Angle::set_iatom1(const int ia_)
{
  iatom1=ia_;
}

void Angle::set_iatom2(const int ia_)
{
  iatom2=ia_;
}

void Angle::set_iatom3(const int ia_)
{
  iatom3=ia_;
}

double Angle::calc(const double x1,
		   const double y1,
		   const double z1,
		   const double x2,
		   const double y2,
		   const double z2,
		   const double x3,
		   const double y3,
		   const double z3)
{
  double r1,r3,dot;
  double r12[3];
  double r32[3];
  r12[0]=x2-x1;
  r12[1]=y2-y1;
  r12[2]=z2-z1;
  r32[0]=x2-x3;
  r32[1]=y2-y3;
  r32[2]=z2-z3;
  r1=sqrt(r12[0]*r12[0]+r12[1]*r12[1]+r12[2]*r12[2]);
  r3=sqrt(r32[0]*r32[0]+r32[1]*r32[1]+r32[2]*r32[2]);
  dot   =(r12[0]*r32[0]+r12[1]*r32[1]+r12[2]*r32[2]);
  return acos(dot/(r1*r3));
}

double Angle::calc(const Dvector3D r1,
		   const Dvector3D r2,
		   const Dvector3D r3)
{
  return Angle::calc(r1.get_x(),
		     r1.get_y(),
		     r1.get_z(),
		     r2.get_x(),
		     r2.get_y(),
		     r2.get_z(),
		     r3.get_x(),
		     r3.get_y(),
		     r3.get_z());
}

