
#ifndef _ISHI_ATOM_DATA_H_
#define _ISHI_ATOM_DATA_H_

#include <string>

using namespace std ;

class AtomData{

 public:

  AtomData (                    ) ;    
  AtomData ( const int       n  ) ;    
  AtomData ( const AtomData& ad ) ;

  ~AtomData ( ) ;

  void copy  ( const AtomData& ad       );

  void clear (                          );
  void read  ( const string&   filename );
  void write ( const string&   filename );

  string get_symbol        ( const int     ia ) const ;
  double get_bond_distance ( const int     ia ) const ;
  double get_mass_number   ( const int     ia ) const ;
  double get_color_R       ( const int     ia ) const ;
  double get_color_G       ( const int     ia ) const ;
  double get_color_B       ( const int     ia ) const ;
  int    get_atomic_number ( const string& as ) const ;

  static string Default_symbol        ( const int     ia );
  static double Default_bond_distance ( const int     ia );
  static double Default_mass_number   ( const int     ia );
  static double Default_color_R       ( const int     ia );
  static double Default_color_G       ( const int     ia );
  static double Default_color_B       ( const int     ia );
  static int    Default_atomic_number ( const string& as );
  
 private:
  
  int      natom;
  string * symbol;
  double * bond_distance;
  double * mass_number;
  double * color_R;
  double * color_G;
  double * color_B;

  void create(const int n);
};

#endif
