
#ifndef _ISHI_BIO_UNIT_DATA_H_
#define _ISHI_BIO_UNIT_DATA_H_

#include <string>

using namespace std;

class bu_data{
  
 public:
  
  bu_data (                    );
  bu_data ( const bu_data& bud );

  ~bu_data ( );

  void copy( const bu_data& bud );

  void clear      ( );
  void clear_atom ( );
  void clear_bond ( );

  void push_back_atom ( const int    index         ,
                        const string pdb_tag       ,
                        const int    atomic_number ,
                        const int    buff_inc=100  );
  
  void push_back_bond ( const int    index_1       ,
                        const int    index_2       ,
                        const int    buff_inc=100  );

 private:

  // BioUnit

  int       index;
  string    pdb_tag;
  string    abbr_1;
  string    abbr_3;

  // atom in @ BioUnit

  int       atom_n;
  int       atom_n_buff;
  int    *  atom_index;
  string *  atom_pdb_tag;
  int    *  atom_atomic_number;

  void create_atom ( const int n );
  void resize_atom ( const int n );
  
  // bond @ BioUnit

  int   bond_n;
  int   bond_n_buff;
  int * bond_index_1;
  int * bond_index_2;

  void create_bond ( const int n );
  void resize_bond ( const int n );

};

class BioUnitData{

 public:

  BioUnitData();
  BioUnitData(const BioUnitData& bud);

  ~BioUnitData();

  void copy(const BioUnitData& bud);

  void clear();

  void push_back(const BioUnitData& bud);

  static string Default_abbr_1             ( const int    index_        );
  static string Default_abbr_3             ( const int    index_        );
  static int    Default_index              ( const string pdb_tag_      );
  static string Default_atom_pdb_tag       ( const int    atom_index_   );
  static int    Default_atom_index         ( const string pdb_tag_      ,
                                             const string atom_pdb_tag_ );
  static int    Default_atom_atomic_number ( const string pdb_tag_      ,
                                             const string atom_pdb_tag_ );
  static int    Default_bond_n             ( const int    index_        );
  static int    Default_bond_index_1       ( const int    index_        ,
                                             const int    ibond         );
  static int    Default_bond_index_2       ( const int    index_        ,
                                             const int    ibond         );
  
 private:

  int       data_n;
  int       data_n_buff;
  bu_data * data;
  
  void create(const int n);
  void resize(const int n);
};

#endif


