
////////////////////                              ///////////////////
////////////////////     Bond class ; Header      ///////////////////
////////////////////                              ///////////////////

#ifndef _ISHI_BOND_H_
#define _ISHI_BOND_H_

#include <string>
#include "ViewBond.h"

using namespace std;

class Bond{
  
 public:
  
  /*-------------------*/
  /*--- constractor ---*/
  /*-------------------*/

  Bond ( ) ;    
  Bond ( const int ia1, const int ia2 ) ;
  Bond ( const Bond& b ) ;

  /*------------------*/
  /*--- destractor ---*/
  /*------------------*/
  
  ~Bond ( ) ;

  /*------------*/
  /*--- copy ---*/
  /*------------*/

  void copy ( const Bond& b ) ;
  void copy ( const ViewBond& vb_ ) ;
  
  /*------------*/
  /*--- bond ---*/
  /*------------*/
  
  int      get_iatom1   ( ) const ;
  int      get_iatom2   ( ) const ;
  int      get_chk_view ( ) const ;
  ViewBond get_vb       ( ) const ;
  string   get_type_mol2( ) const ;
  void     set_iatom1   ( const int ia1 ) ;
  void     set_iatom2   ( const int ia2 ) ;
  void     set_chk_view ( const int n   ) ;
  void     set_type_mol2( const string s) ;
  void     set_color    ( const double R,
                          const double G,
                          const double B) ;

 private:

  /*----------------------*/
  /*--- private member ---*/
  /*----------------------*/
  
  int      iatom1;
  int      iatom2;
  int      chk_view;
  string   type_mol2;
  ViewBond vb;
};

#endif
