
////////////////////                          ///////////////////
////////////////////     Bond class ; CPP     ///////////////////
////////////////////                          ///////////////////

#include <string>
#include "Bond.h"

using namespace std ;

Bond::Bond()
{
  iatom1=-1;
  iatom2=-1;
  chk_view=-1;
  type_mol2="";
}

Bond::Bond(const int ia1, 
           const int ia2)
{
  iatom1=ia1;
  iatom2=ia2;
  chk_view=-1;
  type_mol2="";
}

Bond::Bond(const Bond& b)
{
  iatom1=-1;
  iatom2=-1;
  chk_view=-1;
  type_mol2="";
  copy(b);
}

Bond::~Bond()
{
}

void Bond::copy(const Bond& b)
{
  if(this==&b) return;
  iatom1=b.iatom1;
  iatom2=b.iatom2;
  chk_view=b.chk_view;
  type_mol2=b.type_mol2;
  vb.copy(b.vb);
}

void Bond::copy(const ViewBond& vb_)
{
  vb.copy(vb_);
}

int Bond::get_iatom1 ( ) const
{ 
  return iatom1 ;
}

int Bond::get_iatom2 ( ) const
{
  return iatom2 ;
}

int Bond::get_chk_view ( ) const
{
  return chk_view ;
}

string Bond::get_type_mol2 ( ) const
{
  return type_mol2 ;
}

ViewBond Bond::get_vb ( ) const
{
  return vb;
}

void Bond::set_color(const double R,
                     const double G,
                     const double B)
{
  vb.set_color_R1(R);
  vb.set_color_G1(G);
  vb.set_color_B1(B);
  vb.set_color_R2(R);
  vb.set_color_G2(G);
  vb.set_color_B2(B);
}

void Bond::set_iatom1 ( const int ia1 )
{
  iatom1=ia1;
}

void Bond::set_iatom2 ( const int ia2 )
{
  iatom2=ia2;
}

void Bond::set_chk_view ( const int n )
{
  chk_view=n;
}

void Bond::set_type_mol2 ( const string s )
{
  type_mol2=s;
}
