
////////////////////                                  ///////////////////
////////////////////     Dihedral class ; Header      ///////////////////
////////////////////                                  ///////////////////

#ifndef _ISHI_Dihedral_H_
#define _ISHI_Dihedral_H_

#include <string>
#include "Dvector3D.h"

using namespace std;

class Dihedral{

 public:

  /*-------------------*/
  /*--- constractor ---*/
  /*-------------------*/

  Dihedral ( ) ;    
  Dihedral ( const int ia1, 
	     const int ia2, 
	     const int ia3, 
	     const int ia4 ) ;
  Dihedral ( const Dihedral& di ) ;

  /*------------------*/
  /*--- destractor ---*/
  /*------------------*/
  
  ~Dihedral ( ) ;

  /*------------*/
  /*--- copy ---*/
  /*------------*/
  
  void copy ( const Dihedral& di ) ;

  int get_iatom1 ( ) const ;
  int get_iatom2 ( ) const ;
  int get_iatom3 ( ) const ; 
  int get_iatom4 ( ) const ; 
  int get_chk_improper () const ;

  void set_iatom1(const int ia_);
  void set_iatom2(const int ia_);
  void set_iatom3(const int ia_);
  void set_iatom4(const int ia_);
  void set_improper_on () ;
  void set_improper_off() ; 

  static double calc(const double    x1,
		     const double    y1,
		     const double    z1,
		     const double    x2,
		     const double    y2,
		     const double    z2,
		     const double    x3,
		     const double    y3,
		     const double    z3,
		     const double    x4,
		     const double    y4,
		     const double    z4);

  static double calc(const Dvector3D r1,
		     const Dvector3D r2,
		     const Dvector3D r3,
		     const Dvector3D r4);
  
 private:
  
  int iatom1;
  int iatom2;
  int iatom3;
  int iatom4;
  int chk_improper; // 0 : not improper , 1 : improper

};

#endif
