
#ifndef _ISHI_EYE_H_
#define _ISHI_EYE_H_

#include "Dvector3D.h"

class Eye{

 public:

  ///////////////////////
  ///// constractor /////
  ///////////////////////

  Eye                                      (                             ) ;    
  Eye                                      ( const Eye&       e          ) ;

  ////////////////////// 
  ///// destractor /////
  ////////////////////// 

  ~Eye                                     (                             ) ;

  /////////////////////////
  ///// public method /////
  /////////////////////////

  void      copy                           ( const Eye&       e          ) ;
  double    get_fovy                       (                             ) const ;
  double    get_zfar                       (                             ) const ;
  double    get_znear                      (                             ) const ;
  Dvector3D get_R                          (                             ) const ;
  Dvector3D get_eyeAxis_x                  (                             ) const ;
  Dvector3D get_eyeAxis_y                  (                             ) const ;
  Dvector3D get_eyeAxis_z                  (                             ) const ;
  void      set_fovy                       ( const double     fovy_      ) ;
  void      set_zfar                       ( const double     zfar_      ) ;
  void      set_znear                      ( const double     znear_     ) ;
  void      set_R                          ( const Dvector3D& R_         ) ;
  void      add_R                          ( const Dvector3D& R_         ) ;
  void      set_eyeAxis_x                  ( const Dvector3D& x_         ) ;
  void      set_eyeAxis_y                  ( const Dvector3D& y_         ) ;
  void      set_eyeAxis_z                  ( const Dvector3D& z_         ) ;
  Dvector3D R_to_eyeR                      ( const Dvector3D& r          ) const ;
  Dvector3D eyeR_to_R                      ( const Dvector3D& r          ) const ;
  void      eyeAxis_z_to_r                 ( const Dvector3D& r          ) ;
  void      eyeAxis_rotate_eyeAxis_x       ( const double     angle      ) ;
  void      eyeAxis_rotate_eyeAxis_y       ( const double     angle      ) ;
  void      eyeAxis_rotate_eyeAxis_z       ( const double     angle      ) ;
  void      eyeAxis_reset_for_z            (                             ) ;
  void      translate                      ( const double     l          ,
                                             const Dvector3D& to         ) ;
  void      translate_x                    ( const double     l          ) ;
  void      translate_y                    ( const double     l          ) ;
  void      translate_z                    ( const double     l          ) ;
  void      translate_fixed_view           ( const double     l          ,
                                             const Dvector3D& to         ,
                                             const Dvector3D& view_point ) ;
  void      translate_fixed_view_x         ( const double     l          ,
                                             const Dvector3D& view_point ) ;
  void      translate_fixed_view_y         ( const double     l          ,
                                             const Dvector3D& view_point ) ;
  void      translate_fixed_view_z         ( const double     l          ,
                                             const Dvector3D& view_point ) ;
  void      translate_eyeAxis              ( const double     l          ,
                                             const Dvector3D& to         ) ;
  void      translate_eyeAxis_x            ( const double     l          ) ;
  void      translate_eyeAxis_y            ( const double     l          ) ;
  void      translate_eyeAxis_z            ( const double     l          ) ;
  void      translate_eyeAxis_fixed_view   ( const double     l          ,
                                             const Dvector3D& to         ,
                                             const Dvector3D& view_point ) ;
  void      translate_eyeAxis_fixed_view_x ( const double     l          ,
                                             const Dvector3D& view_point ) ;
  void      translate_eyeAxis_fixed_view_y ( const double     l          ,
                                             const Dvector3D& view_point ) ;
  void      translate_eyeAxis_fixed_view_z ( const double     l          , 
                                             const Dvector3D& view_point ) ;
  void      rotate                         ( const double     ang_       ,
                                             const Dvector3D& axis       ,
                                             const Dvector3D& origin     ) ;
  void      rotate_x                       ( const double     ang_       ,
                                             const Dvector3D& origin     ) ;
  void      rotate_y                       ( const double     ang_       ,
                                             const Dvector3D& origin     ) ;
  void      rotate_z                       ( const double     ang_       ,
                                             const Dvector3D& origin     ) ;
  void      rotate_fixed_view              ( const double     ang_       ,
                                             const Dvector3D& axis       ,
                                             const Dvector3D& origin     ,
                                             const Dvector3D& view_point ) ;
  void      rotate_fixed_view_x            ( const double     ang_       ,
                                             const Dvector3D& origin     ,
                                             const Dvector3D& view_point ) ;
  void      rotate_fixed_view_y            ( const double     ang_       ,
                                             const Dvector3D& origin     ,
                                             const Dvector3D& view_point ) ;
  void      rotate_fixed_view_z            ( const double     ang_       ,
                                             const Dvector3D& origin     ,
                                             const Dvector3D& view_point ) ;
  void      rotate_eyeAxis                 ( const double     ang_       ,
                                             const Dvector3D& axis       ,
                                             const Dvector3D& origin     ) ;
  void      rotate_eyeAxis_x               ( const double     ang_       ,
                                             const Dvector3D& origin     ) ;
  void      rotate_eyeAxis_y               ( const double     ang_       ,
                                             const Dvector3D& origin     ) ;
  void      rotate_eyeAxis_z               ( const double     ang_       ,
                                             const Dvector3D& origin     ) ;
  void      rotate_eyeAxis_fixed_view      ( const double     ang_       ,
                                             const Dvector3D& axis       ,
                                             const Dvector3D& origin     ,
                                             const Dvector3D& view_point ) ;
  void      rotate_eyeAxis_fixed_view_x    ( const double     ang_       ,
                                             const Dvector3D& origin     ,
                                             const Dvector3D& view_point ) ;
  void      rotate_eyeAxis_fixed_view_y    ( const double     ang_       ,
                                             const Dvector3D& origin     ,
                                             const Dvector3D& view_point ) ;
  void      rotate_eyeAxis_fixed_view_z    ( const double     ang_       ,
                                             const Dvector3D& origin     ,
                                             const Dvector3D& view_point ) ;

 private:

  //////////////////////////
  ///// private member /////
  //////////////////////////

  double    fovy;
  double    zfar ;
  double    znear ;
  Dvector3D R ;
  Dvector3D eyeAxis_x ;
  Dvector3D eyeAxis_y ;
  Dvector3D eyeAxis_z ;
};

#endif
