#include "ForceField.h"

using namespace std ;

string ForceField::autodock_get_atom_type ( const int ai )
{
  /* term == 0  : not term */
  /* term == 1  : N-term   */
  /* term == 2  : C-term   */

  string s;

  // main-chain
  if (ai==   0) {s="C"  ; return s;}  
  if (ai==   1) {s="C"  ; return s;}  
  if (ai==   2) {s="N"  ; return s;}  
  if (ai==   4) {s="OA" ; return s;}  
  if (ai==   5) {s="HD" ; return s;}  
  if (ai==  10) {s="HD" ; return s;}  
  if (ai==  11) {s="HD" ; return s;}  
  if (ai==  12) {s="HD" ; return s;}
  if (ai==  81) {s="C"  ; return s;} // ACE
  if (ai==  82) {s="OA" ; return s;} // ACE
  if (ai==  83) {s="C"  ; return s;} // ACE
  if (ai==  87) {s="N"  ; return s;} // NME  
  if (ai==  88) {s="HD" ; return s;} // NME
  if (ai==  89) {s="C"  ; return s;} // NME

  // ala
  if (ai== 205) {s="C"  ; return s;}

  // val
  if (ai== 305) {s="C"  ; return s;}
  if (ai== 307) {s="C"  ; return s;}
  if (ai== 306) {s="C"  ; return s;}

  // lue
  if (ai== 405) {s="C"  ; return s;}
  if (ai== 406) {s="C"  ; return s;}
  if (ai== 407) {s="C"  ; return s;}
  if (ai== 408) {s="C"  ; return s;}

  // ile
  if (ai== 505) {s="C"  ; return s;}
  if (ai== 506) {s="C"  ; return s;}
  if (ai== 507) {s="C"  ; return s;}
  if (ai== 508) {s="C"  ; return s;}

  // met
  if (ai== 605) {s="C"  ; return s;}
  if (ai== 606) {s="C"  ; return s;}
  if (ai== 607) {s="SA" ; return s;}
  if (ai== 608) {s="C"  ; return s;}

  // pro
  if (ai== 707) {s="C"  ; return s;}
  if (ai== 706) {s="C"  ; return s;}
  if (ai== 705) {s="C"  ; return s;}

  // phe
  if (ai== 805) {s="C"  ; return s;}
  if (ai== 806) {s="A"  ; return s;}
  if (ai== 808) {s="A"  ; return s;}
  if (ai== 810) {s="A"  ; return s;}
  if (ai== 811) {s="A"  ; return s;}
  if (ai== 809) {s="A"  ; return s;}
  if (ai== 807) {s="A"  ; return s;}

  // trp
  if (ai== 905) {s="C"  ; return s;}
  if (ai== 906) {s="A"  ; return s;}
  if (ai== 907) {s="A"  ; return s;}
  if (ai== 908) {s="A"  ; return s;}
  if (ai== 909) {s="N"  ; return s;}
  if (ai== 910) {s="A"  ; return s;}
  if (ai== 911) {s="A"  ; return s;}
  if (ai== 912) {s="A"  ; return s;}
  if (ai== 913) {s="A"  ; return s;}
  if (ai== 914) {s="A"  ; return s;}
  if (ai== 918) {s="HD" ; return s;}
 
  // ser
  if (ai==1005) {s="C"  ; return s;}
  if (ai==1006) {s="OA" ; return s;}
  if (ai==1009) {s="HD" ; return s;}

  // thr
  if (ai==1105) {s="C"  ; return s;}
  if (ai==1106) {s="C"  ; return s;}
  if (ai==1107) {s="OA" ; return s;}
  if (ai==1112) {s="HD" ; return s;}

  // asn
  if (ai==1205) {s="C"  ; return s;}
  if (ai==1206) {s="C"  ; return s;}
  if (ai==1207) {s="N"  ; return s;}
  if (ai==1212) {s="HD" ; return s;}
  if (ai==1211) {s="HD" ; return s;}
  if (ai==1208) {s="OA" ; return s;}

  // gln
  if (ai==1305) {s="C"  ; return s;}
  if (ai==1306) {s="C"  ; return s;}
  if (ai==1307) {s="C"  ; return s;}
  if (ai==1309) {s="OA" ; return s;}
  if (ai==1308) {s="N"  ; return s;}
  if (ai==1314) {s="HD" ; return s;}
  if (ai==1315) {s="HD" ; return s;}

  // tyr
  if (ai==1405) {s="C"  ; return s;}
  if (ai==1406) {s="A"  ; return s;}
  if (ai==1407) {s="A"  ; return s;}
  if (ai==1409) {s="A"  ; return s;}
  if (ai==1411) {s="A"  ; return s;}
  if (ai==1410) {s="A"  ; return s;}
  if (ai==1408) {s="A"  ; return s;}
  if (ai==1412) {s="OA" ; return s;}
  if (ai==1419) {s="HD" ; return s;}

  // cys
  if (ai==1505) {s="C"  ; return s;}
  if (ai==1506) {s="SA" ; return s;}
  if (ai==1509) {s="HD" ; return s;}

  // lys
  if (ai==1605) {s="C"  ; return s;}
  if (ai==1606) {s="C"  ; return s;}
  if (ai==1607) {s="C"  ; return s;}
  if (ai==1608) {s="C"  ; return s;}
  if (ai==1609) {s="N"  ; return s;}
  if (ai==1620) {s="HD" ; return s;}
  if (ai==1619) {s="HD" ; return s;}
  if (ai==1618) {s="HD" ; return s;}

  // arg
  if (ai==1705) {s="C"  ; return s;}
  if (ai==1706) {s="C"  ; return s;}
  if (ai==1707) {s="C"  ; return s;}
  if (ai==1708) {s="N"  ; return s;}
  if (ai==1709) {s="C"  ; return s;}
  if (ai==1711) {s="N"  ; return s;}
  if (ai==1710) {s="N"  ; return s;}
  if (ai==1722) {s="HD" ; return s;}
  if (ai==1721) {s="HD" ; return s;}
  if (ai==1719) {s="HD" ; return s;}
  if (ai==1720) {s="HD" ; return s;}
  if (ai==1718) {s="HD" ; return s;}

  // his
  if (ai==1805) {s="C"  ; return s;}
  if (ai==1806) {s="A"  ; return s;}
  if (ai==1807) {s="A"  ; return s;}
  if (ai==1809) {s="N"  ; return s;}
  if (ai==1810) {s="A"  ; return s;}
  if (ai==1814) {s="HD" ; return s;}
  if (ai==1815) {s="HD" ; return s;}
  if (ai==1816) {s="HD" ; return s;}
  if (ai==1808) {s="NA" ; return s;}

  // asp
  if (ai==1905) {s="C"  ; return s;}
  if (ai==1906) {s="C"  ; return s;}
  if (ai==1907) {s="OA" ; return s;}
  if (ai==1908) {s="OA" ; return s;}

  // glu
  if (ai==2005) {s="C"  ; return s;}
  if (ai==2006) {s="C"  ; return s;}
  if (ai==2007) {s="C"  ; return s;}
  if (ai==2009) {s="OA" ; return s;}
  if (ai==2008) {s="OA" ; return s;}

  //cout << "ForceField::autodock_get_atom_type , ai=" << ai << " is not defined!" << endl ; 
  s="**";
  return s;
}

int ForceField::autodock_charge (const string   a1,
                                 const string   pdb_in,
                                 const int      res_type,
                                 const int      terminal_,
                                 double       * out_ch,
                                 const int      info_1)
{
  return ForceField::amber_force_field_charge(a1,pdb_in,res_type,terminal_,out_ch,info_1);
}

int ForceField::autodock_field_vdw ( const string  atype  ,
                                     double       * out_r ,
                                     double       * out_e )
{
  if(atype=="H" ){*out_r= 1.20; *out_e=  0.016  ; return 1;}
  if(atype=="HD"){*out_r= 1.20; *out_e=  0.016  ; return 1;}
  if(atype=="HS"){*out_r= 1.20; *out_e=  0.016  ; return 1;}
  if(atype=="C" ){*out_r= 3.81; *out_e=  0.086  ; return 1;}
  if(atype=="A" ){*out_r= 3.81; *out_e=  0.086  ; return 1;}
  if(atype=="N" ){*out_r= 3.65; *out_e=  0.170  ; return 1;}
  if(atype=="NA"){*out_r= 3.65; *out_e=  0.170  ; return 1;}
  if(atype=="NS"){*out_r= 3.65; *out_e=  0.170  ; return 1;}
  if(atype=="OA"){*out_r= 3.32; *out_e=  0.210  ; return 1;}
  if(atype=="OS"){*out_r= 3.32; *out_e=  0.210  ; return 1;}
  if(atype=="F" ){*out_r= 3.50; *out_e=  0.061  ; return 1;}
  if(atype=="NA"){*out_r= 3.73; *out_e=  0.00277; return 1;}
  if(atype=="MG"){*out_r= 1.59; *out_e=  0.895  ; return 1;}
  if(atype=="P" ){*out_r= 4.20; *out_e=  0.200  ; return 1;}
  if(atype=="SA"){*out_r= 4.00; *out_e=  0.250  ; return 1;}
  if(atype=="S" ){*out_r= 4.00; *out_e=  0.250  ; return 1;}
  if(atype=="CL"){*out_r= 3.90; *out_e=  0.265  ; return 1;}
  if(atype=="K" ){*out_r= 5.31; *out_e=  0.00033; return 1;}
  if(atype=="CA"){*out_r= 3.43; *out_e=  0.4598 ; return 1;}
  if(atype=="ZN"){*out_r= 2.22; *out_e=  0.0125 ; return 1;}
  if(atype=="BR"){*out_r= 4.44; *out_e=  0.320  ; return 1;}
  if(atype=="RB"){*out_r= 5.91; *out_e=  0.00017; return 1;}
  if(atype=="I" ){*out_r= 4.72; *out_e=  0.400  ; return 1;}
  if(atype=="CS"){*out_r= 6.79; *out_e=  0.00008; return 1;}
  if(atype=="G" ){*out_r= 4.00; *out_e=  0.086  ; return 1;}
  if(atype=="GA"){*out_r= 4.00; *out_e=  0.086  ; return 1;}
  *out_r=0.0;
  *out_e=0.0;
  return 0;
}
