
#ifndef _ISHI_FRAGMENT_H_
#define _ISHI_FRAGMENT_H_

#include <string>

using namespace std;

class Fragment{
  
 public:
  
  Fragment ( ) ;    
  Fragment ( const Fragment& f ) ;

  ~Fragment ( ) ;
  
  void copy ( const Fragment& f ) ;

  void clear (  ) ;

  static Fragment unit_fragment  (const Fragment& f1,
                                  const Fragment& f2); 

  int  get_n_atom_index          (                             ) const ;
  int  get_n_link                (                             ) const ;
  int  get_n_elec                (                             ) const ;
  int  get_chk_view              (                             ) const ;
  int  get_atom_index            ( const int iatom             ) const ;
  int  get_atom_index_link1      ( const int ilink             ) const ;
  int  get_atom_index_link2      ( const int ilink             ) const ;
  int  get_opt                   (                             ) const ; 
  int  get_abmd                  (                             ) const ;
  int  chk_atom_in               ( const int index             ) const ;
  void set_opt                   ( const int opt_              )       ;
  void set_abmd                  ( const int abmd_             )       ;
  void set_chk_view              ( const int n                 )       ;
  void push_back_atom_index      ( const int iatom             , 
                                   const int buff_increase=100 )       ;
  void pick_up_atom_index        ( const int iatom             )       ;
  void push_back_atom_index_link ( const int iatom1            ,
                                   const int iatom2            ,
                                   const int buff_increase=1   )       ;
  void pick_up_atom_index_link   ( const int ilink             )       ;
  void push_back_elec            ( const int n                 )       ;
  void pick_up_elec              ( const int n                 )       ;
  
 private:

  int  n_atom_index;
  int  n_atom_index_buff;
  int  n_link;
  int  n_link_buff;
  int  n_elec;
  int  chk_view;
  int  opt; // 0:R1 , 1:R2
  int  abmd; // 0:QM , 1:MM
  int* atom_index;
  int* atom_index_link1; // this atom belong to another fragment (bad , added atom)
  int* atom_index_link2; // this atom belong to this fragment

  void clear_atom_index ( );
  void clear_atom_index_link ( );
  void create_atom_index ( const int n );
  void create_atom_index_link(  const int n );
  void resize_atom_index ( const int n );
  void resize_atom_index_link ( const int n );
};

#endif
