
#ifndef _ISHI_LINKGROUP_H_
#define _ISHI_LINKGROUP_H_

using namespace std;

class LinkGroup{
  
 public:

  LinkGroup                   (                                    )       ;    
  LinkGroup                   ( const LinkGroup& lg                )       ;

  ~LinkGroup                  (                                    )       ;

  void   copy                 ( const LinkGroup& lg                )       ;
  void   clear                (                                    )       ;

  int    get_n_atom_index     (                                    ) const ;
  int    get_atom_index       ( const int        iatom             ) const ;
  int    get_residue_index    (                                    ) const ;
  string get_type             (                                    ) const ;
  int    get_not_peptide      (                                    ) const ;
  int    get_not_dna          (                                    ) const ;

  int    chk_atom_in          ( const int        index             ) const ;
  void   push_back_atom_index ( const int        iatom             , 
                                const int        buff_increase=100 )       ;
  void   pick_up_atom_index   ( const int        iatom             )       ;
  void   set_residue_index    ( const int        n                 )       ;
  void   set_type             ( const string&    t_                )       ; 
  void   set_not_peptide      ( const int        n_                )       ;
  void   set_not_dna          ( const int        n_                )       ;

 private:

  int    n_atom_index;
  int    n_atom_index_buff;
  int*   atom_index;
  int    residue_index;
  int    not_peptide; // 1: not_peptide
  int    not_dna;     // 1: not_dna
  string type;

  void clear_atom_index  (             );
  void create_atom_index ( const int n );
  void resize_atom_index ( const int n );
};

#endif
