
#ifndef _ISHI_IRECTANGLE_H_
#define _ISHI_IRECTANGLE_H_

#include "Dvector3D.h"
#include <cstring>

using namespace std ;

class iRectangle{

 public:
  
  ///////////////////////
  ///// constractor /////
  ///////////////////////

  iRectangle();
  iRectangle(const iRectangle& r);

  ////////////////////// 
  ///// destractor /////
  ////////////////////// 

  ~iRectangle() ;

  /////////////////////////
  ///// public method /////
  /////////////////////////

  void copy(const iRectangle& r) ;

  double    get_lx       () const ;
  double    get_ly       () const ;
  double    get_lz       () const ;
  Dvector3D get_center   () const ;
  int       get_view_chk () const ;
  int       get_style    () const ;
  int       get_width    () const ;
  double    get_cr       () const ;
  double    get_cg       () const ;
  double    get_cb       () const ;
  void      get_vertex_2 (double * v1,
                          double * v2,
                          double * v3,
                          double * v4,
                          double * v5,
                          double * v6,
                          double * v7,
                          double * v8) const ;
  void      get_vertex_1 (double * v1,
                          double * v2,
                          double * v3,
                          double * v4,
                          double * v5,
                          double * v6,
                          double * v7,
                          double * v8) const ;
  
  void set_lx        ( const double     lx_);
  void set_ly        ( const double     ly_);
  void set_lz        ( const double     lz_);
  void set_center    ( const Dvector3D& c);
  void set_view_chk  ( const int        view_chk_) ;
  void set_style     ( const int        style_) ;
  void set_width     ( const int        width_) ;
  void set_cr        ( const double     cr_) ;
  void set_cg        ( const double     cg_) ;
  void set_cb        ( const double     cb_) ;
  void print_01      (                     ) const ;
  
  void read_bude_lib  ( const string& filename ) ;
  void write_bude_lib ( const string& filename ) const ;
  
 private:

  //////////////////////////
  ///// private member /////
  //////////////////////////

  double    lx;       // bohr
  double    ly;       // bohr
  double    lz;       // bohr
  Dvector3D center;   // bohr
  int       view_chk; // 0:not view , 1:view
  int       style;    // 1:line , 2:solid
  int       width;    
  double    cr;
  double    cg;
  double    cb;    
};

#endif
