
#include "iRectangle.h"
#include "iString.h"
#include <cstring>
#include <fstream>
#include <cstdlib>

using namespace std ;

iRectangle::iRectangle()
{
  lx=1.0; 
  ly=1.0;
  lz=1.0;
  center.set_xyz(0.0,0.0,0.0);
  view_chk=0; // not view
  style=1; // line
  width=2;
  cr=1.0;
  cg=1.0;
  cb=1.0;    
}

iRectangle::iRectangle(const iRectangle& r)
{
  copy(r);
}

iRectangle::~iRectangle()
{
  //cout << "in  ishi in ~iRectangel" << endl ;
  //cout << "out ishi in ~iRectangel" << endl ;
}

void iRectangle::copy(const iRectangle& r)
{
  if(this==&r) return;
  lx=r.lx;
  ly=r.ly;
  lz=r.lz;
  center.copy(r.center);
  view_chk=r.view_chk;
  style=r.style;
  width=r.width;
  cr=r.cr;
  cg=r.cg;
  cb=r.cb;
}

double iRectangle::get_lx() const 
{
  return lx;
}

double iRectangle::get_ly() const
{
  return ly;
}

double iRectangle::get_lz() const
{
  return lz;
}

Dvector3D iRectangle::get_center() const
{
  return center;
}

int iRectangle::get_view_chk() const
{
  return view_chk;
}

int iRectangle::get_style() const
{
  return style;
}

int iRectangle::get_width() const
{
  return width;
}

double iRectangle::get_cr() const
{
  return cr;
}

double iRectangle::get_cg() const
{
  return cg;
}

double iRectangle::get_cb() const
{
  return cb;
}

void iRectangle::set_lx(const double lx_)
{
  lx=lx_;
}
 
void iRectangle::set_ly(const double ly_)
{
  ly=ly_;
}

void iRectangle::set_lz(const double lz_)
{
  lz=lz_;
}
 
void iRectangle::set_center(const Dvector3D& c)
{
  center.copy(c);
}

void iRectangle::set_view_chk(const int view_chk_)
{
  view_chk=view_chk_;
}

void iRectangle::set_style(const int style_)
{
  style=style_;
}
 
void iRectangle::set_width(const int width_)
{
  width=width_;
}

void iRectangle::set_cr(const double cr_)
{
  cr=cr_;
}

void iRectangle::set_cg(const double cg_)
{
  cg=cg_;
}

void iRectangle::set_cb(const double cb_)
{
  cb=cb_;
}

void iRectangle::get_vertex_1(double * v1,
                             double * v2,
                             double * v3,
                             double * v4,
                             double * v5,
                             double * v6,
                             double * v7,
                             double * v8) const
{
  v1[0]=+lx*0.5+center.get_x();v1[1]=+ly*0.5+center.get_y();v1[2]=+lz*0.5+center.get_z();
  v2[0]=-lx*0.5+center.get_x();v2[1]=+ly*0.5+center.get_y();v2[2]=+lz*0.5+center.get_z();
  v3[0]=-lx*0.5+center.get_x();v3[1]=+ly*0.5+center.get_y();v3[2]=-lz*0.5+center.get_z();
  v4[0]=+lx*0.5+center.get_x();v4[1]=+ly*0.5+center.get_y();v4[2]=-lz*0.5+center.get_z();
  v5[0]=+lx*0.5+center.get_x();v5[1]=-ly*0.5+center.get_y();v5[2]=+lz*0.5+center.get_z();
  v6[0]=-lx*0.5+center.get_x();v6[1]=-ly*0.5+center.get_y();v6[2]=+lz*0.5+center.get_z();
  v7[0]=-lx*0.5+center.get_x();v7[1]=-ly*0.5+center.get_y();v7[2]=-lz*0.5+center.get_z();
  v8[0]=+lx*0.5+center.get_x();v8[1]=-ly*0.5+center.get_y();v8[2]=-lz*0.5+center.get_z();
}

void iRectangle::get_vertex_2(double * v1,
                              double * v2,
                              double * v3,
                              double * v4,
                              double * v5,
                              double * v6,
                              double * v7,
                              double * v8) const
{
  // 1-->2-->3-->4
  // 1-->4-->8-->5
  // 1-->5-->6-->2
  // 2-->6-->7-->3
  // 3-->7-->8-->4
  // 5-->8-->7-->6
  v1[0] = +lx*0.5 ; v1[1] = +ly*0.5 ; v1[2] = +lz*0.5;
  v2[0] = -lx*0.5 ; v2[1] = +ly*0.5 ; v2[2] = +lz*0.5;
  v3[0] = -lx*0.5 ; v3[1] = +ly*0.5 ; v3[2] = -lz*0.5;
  v4[0] = +lx*0.5 ; v4[1] = +ly*0.5 ; v4[2] = -lz*0.5;
  v5[0] = +lx*0.5 ; v5[1] = -ly*0.5 ; v5[2] = +lz*0.5;
  v6[0] = -lx*0.5 ; v6[1] = -ly*0.5 ; v6[2] = +lz*0.5;
  v7[0] = -lx*0.5 ; v7[1] = -ly*0.5 ; v7[2] = -lz*0.5;
  v8[0] = +lx*0.5 ; v8[1] = -ly*0.5 ; v8[2] = -lz*0.5;
}

void iRectangle::write_bude_lib(const string& filename) const 
{
  int nx,ny,nz;
  double cx,cy,cz,x,y,z;
  cx=center.get_x();
  cy=center.get_y();
  cz=center.get_z();
  x=cx;
  nx=0;
  while(1){
    if((cx-x)>(lx/2.0+0.1)){
      break;
    }
    nx++;
    x=x-(1.0/0.5291);
  }
  y=cy;
  ny=0;
  while(1){
    if((cy-y)>(ly/2.0+0.1)){
      break;
    }
    ny++;
    y=y-(1.0/0.5291);
  }
  z=cz;
  nz=0;
  while(1){
    if((cz-z)>(lz/2.0+0.1)){
      break;
    }
    nz++;
    z=z-(1.0/0.5291);
  }

  ofstream fout(filename.c_str(), ios_base::out );
  fout.setf(ios::fixed,ios::floatfield);
  fout.precision(2);

  fout << "%%TRANSFORMATIONS LIBRARY" << endl ;
  fout << "%VERSION 2.00" << endl ;
  fout << "TILT 36" << endl ;
  for(int i=0;i<36;i++){
    fout.width(6) ; fout << -170.0+(10.0*i) << endl ;;
  }
  fout << "ROLL 36" << endl ;
  for(int i=0;i<36;i++){
    fout.width(6) ; fout << -170.0+(10.0*i) << endl ;
  }
  fout << "PAN  36" << endl ;
  for(int i=0;i<36;i++){
    fout.width(6) ; fout << -170.0+(10.0*i) << endl ;
  }
  fout << "XTRANS " << 2*nx+1 << endl ; 
  fout.width(6); fout << x*0.5291 << endl ;
  for(int i=0;i<(2*nx);i++){
    x=x+1.0/0.5291;
    fout.width(6); fout << x*0.5291 << endl ;
  }
  fout << "YTRANS " << 2*ny+1 << endl ; 
  fout.width(6); fout << y*0.5291 << endl ;
  for(int i=0;i<(2*ny);i++){
    y=y+1.0/0.5291;
    fout.width(6); fout << y*0.5291 << endl ;
  }
  fout << "ZTRANS " << 2*nz+1 << endl ; 
  fout.width(6); fout << z*0.5291 << endl ;
  for(int i=0;i<(2*nz);i++){
    z=z+1.0/0.5291;
    fout.width(6); fout << z*0.5291 << endl ;
  }

  fout.close();
}

void iRectangle::print_01() const 
{
  int nx,ny,nz;
  double cx,cy,cz,x,y,z;
  cx=center.get_x();
  cy=center.get_y();
  cz=center.get_z();
  x=cx;
  nx=0;
  while(1){
    if((cx-x)>(lx/2.0+0.1)){
      break;
    }
    nx++;
    x=x-(1.0/0.5291);
  }
  y=cy;
  ny=0;
  while(1){
    if((cy-y)>(ly/2.0+0.1)){
      break;
    }
    ny++;
    y=y-(1.0/0.5291);
  }
  z=cz;
  nz=0;
  while(1){
    if((cz-z)>(lz/2.0+0.1)){
      break;
    }
    nz++;
    z=z-(1.0/0.5291);
  }

  cout.setf(ios::fixed,ios::floatfield);
  cout.precision(2);

  cout << "%%TRANSFORMATIONS LIBRARY" << endl ;
  cout << "%VERSION 2.00" << endl ;

  cout << "TILT 36" << endl ;
  for(int i=0;i<36;i++){
    cout.width(6) ; cout << -170.0+(10.0*i) << endl ;;
  }

  cout << "ROLL 36" << endl ;
  for(int i=0;i<36;i++){
    cout.width(6) ; cout << -170.0+(10.0*i) << endl ;
  }

  cout << "PAN  36" << endl ;
  for(int i=0;i<36;i++){
    cout.width(6) ; cout << -170.0+(10.0*i) << endl ;
  }

  cout << "XTRANS " << 2*nx+1 << endl ; 
  cout.width(6); cout << x*0.5291 << endl ;
  for(int i=0;i<(2*nx);i++){
    x=x+1.0/0.5291;
    cout.width(6); cout << x*0.5291 << endl ;
  }

  cout << "YTRANS " << 2*ny+1 << endl ; 
  cout.width(6); cout << y*0.5291 << endl ;
  for(int i=0;i<(2*ny);i++){
    y=y+1.0/0.5291;
    cout.width(6); cout << y*0.5291 << endl ;
  }

  cout << "ZTRANS " << 2*nz+1 << endl ; 
  cout.width(6); cout << z*0.5291 << endl ;
  for(int i=0;i<(2*nz);i++){
    z=z+1.0/0.5291;
    cout.width(6); cout << z*0.5291 << endl ;
  }
  
}

void iRectangle::read_bude_lib (const string& filename)
{
  int nx,ny,nz;
  double x1,x2,y1,y2,z1,z2,cx,cy,cz;
  char line[1024];
  char buff[1024];
  fstream file(filename.c_str(), std::ios::in);
  //if(file==NULL){ <--- 20150827
  if(!file){
    //s_out = s_out + "\n warning , can not open the file : " + filename + "\n\n";
    return;
  }
  while(! file.eof()){
    file.getline(line, sizeof(line));
    if(iFind(line,"XTRANS")>=0){
      iPickUp(line,1,buff);nx=atoi(buff);
      for(int i=0;i<nx;i++){
        file.getline(line, sizeof(line));
        if(i==0     ){x1=atof(line)/0.5291;}
        if(i==(nx-1)){x2=atof(line)/0.5291;}
      }
    }
    if(iFind(line,"YTRANS")>=0){
      iPickUp(line,1,buff);ny=atoi(buff);
      for(int i=0;i<ny;i++){
        file.getline(line, sizeof(line));
        if(i==0     ){y1=atof(line)/0.5291;}
        if(i==(ny-1)){y2=atof(line)/0.5291;}
      }
    }
    if(iFind(line,"ZTRANS")>=0){
      iPickUp(line,1,buff);nz=atoi(buff);
      for(int i=0;i<nz;i++){
        file.getline(line, sizeof(line));
        if(i==0     ){z1=atof(line)/0.5291;}
        if(i==(nz-1)){z2=atof(line)/0.5291;}
      }
    }
  }
  lx=x2-x1;
  ly=y2-y1;
  lz=z2-z1;
  center.set_xyz(x1+lx/2.0,y1+ly/2.0,z1+lz/2.0);
  file.close();
}
