
#include <string>
#include <ctime>

using namespace std;

//double pv_docking_ang_min_rmsd(const int      pv_docking_rot_bond_n,
double docking_ang_min_rmsd(const int      pv_docking_rot_bond_n,
                               const int      n_ang_1,
                               const double * ang_1,
                               const double * ang_2);

//double pv_docking_ang_min_rmsd_main(const int      pv_docking_rot_bond_n,
double docking_ang_min_rmsd_main(const int      pv_docking_rot_bond_n,
                                    const int      pv_docking_rot_bond_main_n,
                                    const int    * pv_docking_rot_bond_main,
                                    const int      n_ang_1,
                                    const double * ang_1,
                                    const double * ang_2);

//double pv_docking_pos_min_rmsd(const int      n_pos_1,
double docking_pos_min_rmsd(const int      n_pos_1,
                               const double * pos_1,
                               const double * pos_2);

//void pv_docking_get_ligand_info(const string& file_1,
void docking_get_ligand_info(const string& file_1,
                                const string& file_2,
                                int         * atom_n,
                                int         * type_n,
                                int         * bond_n,
                                int         * rot_bond_n,
                                int         * rot_bond_main_n,
                                int         * pair_n);

//void pv_docking_set_ligand_info(const string& file_1,
void docking_set_ligand_info(const string& file_1,
                                const string& file_2,
                                int         * atomic,
                                string      * type,
                                double      * x,
                                double      * y,
                                double      * z,
                                double      * chg,
                                double      * vdw_e,
                                double      * vdw_r,
                                int         * bond_1,
                                int         * bond_2,
                                int         * center_atom,
                                string      * all_type,
                                double      * all_type_vdw_e,
                                double      * all_type_vdw_r,
                                int         * rot_bond,
                                int         * rot_bond_main,
                                int         * rot_bond_atom_n,
                                int         * rot_bond_atom,
                                int         * pair_1,
                                int         * pair_2,
                                double      * pair_coeffA,
                                double      * pair_coeffB);

//void pv_docking_get_protein_info(const string& file_3,
void docking_get_protein_info(const string& file_3,
                                 int * atom_n,
                                 int * bond_n);

//void pv_docking_set_protein_info(const string& file_3,
void docking_set_protein_info(const string& file_3,
                                 const int     pv_docking_pro_n,
                                 const int     pv_docking_pro_bond_n,
                                 int    *      pv_docking_pro_main_bond_n,
                                 int    *      pv_docking_pro_atomic,
                                 int    *      pv_docking_pro_biounit,
                                 int    *      pv_docking_pro_bond_1,
                                 int    *      pv_docking_pro_bond_2,
                                 int    *      pv_docking_pro_main_bond_1,
                                 int    *      pv_docking_pro_main_bond_2,
                                 double *      pv_docking_pro_x,
                                 double *      pv_docking_pro_y,
                                 double *      pv_docking_pro_z,
                                 double *      pv_docking_pro_chg,
                                 double *      pv_docking_pro_vdw_e,
                                 double *      pv_docking_pro_vdw_r);

//void pv_docking_energy_internal(const int      conf_n,
void docking_energy_internal(const int      conf_n,
                                const int      atom_n,
                                const int      pair_n,
                                const int    * pair_1,
                                const int    * pair_2,
                                const double * x,
                                const double * y,
                                const double * z,
                                const double * chg,
                                const double * vdw_e,
                                const double * vdw_r,
                                const double * coeffA,
                                const double * coeffB,
                                const double * external_energy,
                                const double   external_energy_max,
                                double       * eng_chg,
                                double       * eng_vdw,
                                long int     * n_internal);

//void pv_docking_energy_external(const int      conf_n,
void docking_energy_external(const int      conf_n,
                                const int      atom_n,
                                const double * x,
                                const double * y,
                                const double * z,
                                const int    * ix,
                                const int    * iy,
                                const int    * iz,
                                const double * chg,
                                const double * vdw_e,
                                const double * vdw_r,
                                const int      pro_atom_n,
                                const double * pro_x,
                                const double * pro_y,
                                const double * pro_z,
                                const double * pro_chg,
                                const double * pro_vdw_e,
                                const double * pro_vdw_r,
                                double       * eng_chg,
                                double       * eng_vdw,
                                long int     * n_external);

//void pv_docking_energy_external_grid(const int      conf_n,
void docking_energy_external_grid(const int      conf_n,
                                     const int      atom_n,
                                     const double * x,
                                     const double * y,
                                     const double * z,
                                     const int    * type_i,
                                     const int      grid_ntype,
                                     const int      grid_nx,
                                     const int      grid_ny,
                                     const int      grid_nz,
                                     const double   grid_0x,
                                     const double   grid_0y,
                                     const double   grid_0z,
                                     const double   grid_d,
                                     const double * grid,
                                     const int    * ix,
                                     const int    * iy,
                                     const int    * iz,
                                     const double * dx,
                                     const double * dy,
                                     const double * dz,
                                     double       * eng_chg,
                                     double       * eng_vdw,
                                     long int     * n_external);

//void pv_docking_make_conformation_2(const int      conf_n,
void docking_make_conformation_2(const int      conf_n,
                                    const int      atom_n,
                                    const int    * atomic,
                                    const int      center_atom,
                                    const double * x_orig,
                                    const double * y_orig,
                                    const double * z_orig,
                                    const int    * bond_1,
                                    const int    * bond_2,
                                    const int      rot_bond_n,
                                    const int    * rot_bond,
                                    const int    * rot_bond_atom_n,
                                    const int    * rot_bond_atom,
                                    const double * par_ang,
                                    const double * par_pos,
                                    const double * par_rot,
                                    double       * x_out,
                                    double       * y_out,
                                    double       * z_out);

//void pv_docking_make_conformation(const int      conf_n,
void docking_make_conformation(const int      conf_n,
                                  const int      atom_n,
                                  const int    * atomic,
                                  const int      center_atom,
                                  const double * x_orig,
                                  const double * y_orig,
                                  const double * z_orig,
                                  const int    * bond_1,
                                  const int    * bond_2,
                                  const int      rot_bond_n,
                                  const int    * rot_bond,
                                  const int    * rot_bond_atom_n,
                                  const int    * rot_bond_atom,
                                  const double * par_ang,
                                  const double * par_pos,
                                  const double * par_rot,
                                  double       * x_out,
                                  double       * y_out,
                                  double       * z_out);

//void pv_docking_make_grid_position(const int      conf_n,
void docking_make_grid_position(const int      conf_n,
                                   const int      atom_n,
                                   const int      grid_nx,
                                   const int      grid_ny,
                                   const int      grid_nz,
                                   const double   grid_0x,
                                   const double   grid_0y,
                                   const double   grid_0z,
                                   const double   grid_d,                                     
                                   const double * x_out,
                                   const double * y_out,
                                   const double * z_out,
                                   int          * ix_out,
                                   int          * iy_out,
                                   int          * iz_out,
                                   double       * dx_out,
                                   double       * dy_out,
                                   double       * dz_out);

//void pv_docking_setup_par(const int         grid_use,
void docking_setup_par(const int         grid_use,
			  const long int    random_seed,
                          const int         atom_n,
                          const int       * atomic,
                          const int         center_atom,
                          const double    * x,
                          const double    * y,
                          const double    * z,
                          const int       * bond_1,
                          const int       * bond_2,
                          const int         pair_n,
                          const int       * pair_1,
                          const int       * pair_2,
                          const double    * chg,
                          const double    * vdw_e,
                          const double    * vdw_r,
                          const double    * coeffA,
                          const double    * coeffB,
                          const int         pro_atom_n,
                          const double    * pro_x,
                          const double    * pro_y,
                          const double    * pro_z,
                          const double    * pro_chg,
                          const double    * pro_vdw_e,
                          const double    * pro_vdw_r,
                          const int       * type_i,
                          const int         grid_ntype,
                          const int         grid_nx,
                          const int         grid_ny,
                          const int         grid_nz,
                          const double      grid_d,
                          const double    * grid,                            
                          const int         par_n,
                          const int         chk_debug_compare,
                          double          * par_ang,
                          double          * par_pos,
                          double          * par_rot,
                          double          * region,
                          double          * par_eng,
                          double          * par_eng_intra,
                          double          * par_eng_intra_chg,
                          double          * par_eng_intra_vdw,
                          double          * par_eng_inter,
                          double          * par_eng_inter_chg,
                          double          * par_eng_inter_vdw,
                          double          * par_x,
                          double          * par_y,
                          double          * par_z,
                          int               rot_bond_n,
                          int             * rot_bond,
                          int             * rot_bond_atom_n,
                          int             * rot_bond_atom,
                          long int        * n_internal,
                          long int        * n_external,
                          clock_t         * t1,
                          clock_t         * t2,
                          clock_t         * t3);

//void pv_docking_make_chi_angle(const long int random_seed,
void docking_make_chi_angle(const long int random_seed,
                               const int      pv_docking_rot_bond_n,
                               const int      pv_docking_par_n,
                               const double * pv_docking_par_ang,
                               const double * par_pos,
                               const double * par_rot,
                               const double * region,
                               const int      pv_docking_chi_n,
                               double *       pv_docking_chi_ang,
                               double *       chi_pos,
                               double *       chi_rot);

//void pv_docking_sort_chi(const int pv_docking_na,
void docking_sort_chi(const int pv_docking_na,
                         const int pv_docking_rot_bond_n,
                         const int pv_docking_chi_n,
                         double *  pv_docking_chi_ang,
                         double *  chi_pos,
                         double *  chi_rot,
                         double *  pv_docking_chi_eng,
                         double *  pv_docking_chi_eng_intra,
                         double *  pv_docking_chi_eng_inter,
                         double *  pv_docking_chi_x,
                         double *  pv_docking_chi_y,
                         double *  pv_docking_chi_z);

//void pv_docking_select_par(const int      pv_docking_na,
void docking_select_par(const int      pv_docking_na,
                           const int      pv_docking_rot_bond_n,
                           const int      pv_docking_rot_bond_main_n,
                           const int *    pv_docking_rot_bond_main,
                           const int      pv_docking_alpha_n,
                           const int *    pv_docking_alpha,
                           const int      pv_docking_par_n,
                           double *       pv_docking_par_ang,
                           double *       par_pos,
                           double *       par_rot,
                           double *       pv_docking_par_eng,
                           double *       pv_docking_par_eng_intra,
                           double *       pv_docking_par_eng_inter,
                           double *       pv_docking_par_x,
                           double *       pv_docking_par_y,
                           double *       pv_docking_par_z,
                           const int      pv_docking_chi_n,
                           const double * pv_docking_chi_ang,
                           const double * chi_pos,
                           const double * chi_rot,
                           const double * pv_docking_chi_eng,
                           const double * pv_docking_chi_eng_intra,
                           const double * pv_docking_chi_eng_inter,
                           const double * pv_docking_chi_x,
                           const double * pv_docking_chi_y,
                           const double * pv_docking_chi_z);

//void pv_docking_next_par(const int         grid_use,
void docking_next_par(const int         grid_use,
                         const long int    random_seed,
                         const int         atom_n,
                         const int       * atomic,
                         const int         center_atom,
                         const double    * x,
                         const double    * y,
                         const double    * z,
                         const int         bond_n,
                         const int       * bond_1,
                         const int       * bond_2,
                         const int         pair_n,
                         const int       * pair_1,
                         const int       * pair_2,
                         const double    * chg,
                         const double    * vdw_e,
                         const double    * vdw_r,
                         const double    * coeffA,
                         const double    * coeffB,
                         const int         pro_atom_n,
                         const double    * pro_x,
                         const double    * pro_y,
                         const double    * pro_z,
                         const double    * pro_chg,
                         const double    * pro_vdw_e,
                         const double    * pro_vdw_r,
                         const int       * type_i,
                         const int         grid_ntype,
                         const int         grid_nx,
                         const int         grid_ny,
                         const int         grid_nz,
                         const double      grid_d,
                         const double    * grid,
                         const int         rot_bond_n,
                         const int       * rot_bond,
                         const int         rot_bond_main_n,
                         const int       * rot_bond_main,
                         const int       * rot_bond_atom_n,
                         const int       * rot_bond_atom,
                         const int         alpha_n,
                         const int       * alpha,
                         const int         par_n,
                         const int         chk_debug_compare,
                         double          * par_ang,
                         double          * par_pos,
                         double          * par_rot,
                         double          * region,
                         double          * par_eng,
                         double          * par_eng_intra,
                         double          * par_eng_inter,
                         double          * par_x,
                         double          * par_y,
                         double          * par_z,
                         const int         chi_n,
                         double          * chi_x,
                         double          * chi_y,
                         double          * chi_z,
                         double          * chi_eng,
                         double          * chi_eng_intra,
                         double          * chi_eng_inter,
                         long int        * n_internal,
                         long int        * n_external,
                         clock_t         * t1,
                         clock_t         * t2,
                         clock_t         * t3,
                         clock_t         * t4);

//void pv_docking_print_par(const int      na,
void docking_print_par(const int      na,
                          const int      n,
                          const int      n_itr,
                          const int      i_start,
                          const int      pv_docking_rot_bond_n,
                          const int      pv_docking_rot_bond_main_n,
                          const int    * pv_docking_rot_bond_main,
                          const int      pv_docking_alpha_n,
                          const int    * pv_docking_alpha,
                          const double * pv_docking_par_ang,
                          const double * pv_docking_par_pos,
                          const double * pv_docking_par_rot,
                          const double * pv_docking_par_eng,
                          const double * pv_docking_par_eng_intra,
                          const double * pv_docking_par_eng_inter,
                          const int      flag,
                          string&        s_out);

//void pv_docking_set_grid_from_file_head_no_grid_value(const string filename,
void docking_set_grid_from_file_head_no_grid_value(const string filename,
                                                      string * grid_type,
                                                      double * grid_region);

//void pv_docking_set_grid_from_file(const string filename,
void docking_set_grid_from_file(const string filename,
                                   string * grid_type,
                                   double * grid,
                                   double * grid_region);

//void pv_docking_get_grid_info_from_file_head(const string file_head,
void docking_get_grid_info_from_file_head(const string file_head,
                                             int *    grid_nx,
                                             int *    grid_ny,
                                             int *    grid_nz,
                                             double * grid_center_x,
                                             double * grid_center_y,
                                             double * grid_center_z,
                                             double * grid_d,
                                             int *    grid_n,
                                             int *    grid_type_n);

//void pv_docking_get_grid_info_from_file(const string filename,
void docking_get_grid_info_from_file(const string filename,
                                        int *    grid_nx,
                                        int *    grid_ny,
                                        int *    grid_nz,
                                        double * grid_center_x,
                                        double * grid_center_y,
                                        double * grid_center_z,
                                        double * grid_d,
                                        int *    grid_n,
                                        int *    grid_type_n);

//void pv_docking_write_grid(const string  filename,
void docking_write_grid(const string  filename,
                           const int     grid_type_n,
                           const int     grid_nx,
                           const int     grid_ny,
                           const int     grid_nz,
                           const double  grid_center_x,
                           const double  grid_center_y,
                           const double  grid_center_z,
                           const double  grid_d,
                           const string* grid_type,
                           const double* grid);

//void pv_docking_set_grid(const int     grid_type_n,
void docking_set_grid(const int     grid_type_n,
                           const int     grid_nx,
                           const int     grid_ny,
                           const int     grid_nz,
                           const double  grid_center_x,
                           const double  grid_center_y,
                           const double  grid_center_z,
                           const double  grid_d,
                           const int     all_type_n,
                           const string* all_type,
                           const double* all_type_vdw_e,
                           const double* all_type_vdw_r,
                           const int     pro_atom_n,
                           const double* pro_x,
                           const double* pro_y,
                           const double* pro_z,
                           const double* pro_vdw_e,
                           const double* pro_vdw_r,                             
                           string *      grid_type,
                           double *      grid,
                           double *      grid_region);

//void pv_docking_assign_atom_type_to_grid(const int     lig_atom_n,
void docking_assign_atom_type_to_grid(const int     lig_atom_n,
                                         const string* lig_atom_type,
                                         const int     grid_type_n,
                                         const string* grid_type,
                                         int *         lig_atom_type_i);

//void pv_docking_write_pdb_1(const string   filename,
void docking_write_pdb_1(const string   filename,
                            const int      atom_n,
                            const int    * atomic,
                            const int      center_atom,
                            const double * x_orig,
                            const double * y_orig,
                            const double * z_orig,
                            const int      bond_n,
                            const int    * bond_1,
                            const int    * bond_2,
                            const int      rot_bond_n,
                            const int    * rot_bond,
                            const int    * rot_bond_atom_n,
                            const int    * rot_bond_atom,
                            const int      grid_nx,
                            const int      grid_ny,
                            const int      grid_nz,
                            const double   grid_0x,
                            const double   grid_0y,
                            const double   grid_0z,
                            const double   grid_d,                                    
                            const double * par_ang,
                            const double * par_pos,
                            const double * par_rot);




